import java.util.*;
import java.io.*;

public class ClientExample {
    public static void main(String[] args) throws FileNotFoundException {
        Scanner console = new Scanner(System.in);

        System.out.println("Enter 0 to start with a blank item manager \n" + "or 1 to load from file: "); 
        int choice = Integer.parseInt(console.nextLine());
        while (choice != 0 && choice != 1) {
            System.out.println("Invalid choice! Try again");
            choice = Integer.parseInt(console.nextLine());
        }

        CollectionManagerExample collectionManager = null;
        if (choice == 0) {
            collectionManager = new CollectionManagerExample();
        } else if (choice == 1) {
            System.out.print("Enter file to read: ");
            String inFileName = console.nextLine();
            File inFile = new File(inFileName);
            while (!inFile.exists()) {
                System.out.println("  File does not exist. Please try again.");
                System.out.print("Enter file to read: ");
                inFileName = console.nextLine();
                inFile = new File(inFileName);
            }
    
            collectionManager = new CollectionManagerExample(new Scanner(inFile));
            System.out.println("Collection manager created!");
            System.out.println();
        }

        menu(console);
        String option = console.nextLine();
        while (!option.equalsIgnoreCase("quit")) {
            System.out.println();

            if (option.equalsIgnoreCase("add")) {
                // TODO: Call your collection manager's add method and 
                // pass in the result of the Item's parse() method
                collectionManager.add(YarnExample.parse(console));
                System.out.println();
            } else if (option.equalsIgnoreCase("contains")) {
                // TODO: Print the result of your collection manager's 
                // contains method and pass in the result of the Item's parse() method
                System.out.println(collectionManager.contains(YarnExample.parse(console)));
                System.out.println();
            } else if (option.equalsIgnoreCase("print")) {
                System.out.println(collectionManager.toString());
                System.out.println();
            } else if (option.equalsIgnoreCase("creative")) {
                // collectionManager.creativeExtension(); // TODO: Update with any parameters you need!
                System.out.println();
            } else if (option.equalsIgnoreCase("save")) {
                System.out.print("Enter file to save to: ");
                String outFileName = console.nextLine();
                PrintStream outFile = new PrintStream(new File(outFileName));
                collectionManager.save(outFile);
                System.out.println("Collection Manager exported!");
                System.out.println();
            } else if (!option.equalsIgnoreCase("quit")) {
                System.out.println("  Invalid choice. Please try again.");
                System.out.println();
            }

            menu(console);
            option = console.nextLine();
        }
    }

    private static void menu(Scanner console) {
        System.out.println("What would you like to do? Choose an option in brackets.");
        System.out.println("  [add] item");
        System.out.println("  [contains] item");
        System.out.println("  [print] my collection");
        System.out.println("  [save] my collection");
        System.out.println("  [creative] extension");
        System.out.println("  [quit] program");
    }
}
